#include <stdio.h>
#include <stdint.h>
#include <string.h>


int main(int argc, char **argv)
{
    uint32_t reg_key = 0;
    uint32_t sum_bbs_name = 0;
    uint32_t sum_sysop_name = 0;    
    char bbs_name[255] = "";
    char sysop_name[255] = "";
    char reg_key_ascii[12] = "";
    unsigned char local_bbs_name[41] = "";
    unsigned char local_sysop_name[41] = "";
    int i;


    if( argc != 3 )
    {
        printf( "usage: %s \"Sysop Name\" \"BBS Name\"\n\n", argv[0] );
        printf( "NOTE - don't forget the quotes around each name!\n" );
        return 1;
    }

    strncpy( sysop_name, argv[1], sizeof(sysop_name) );
    sysop_name[sizeof(sysop_name)-1] = '\0';
    
    if( strlen(sysop_name) < 3 )
    {
        printf( "Sysop name must be at least 3 characters.\n" );
        return 2;
    }
    
    strncpy( bbs_name, argv[2], sizeof(bbs_name) );
    bbs_name[sizeof(bbs_name)-1] = '\0';
    if( strlen(bbs_name) < 3 )
    {
        printf( "BBS name must be at least 3 characters.\n" );
        return 3;
    }

    for( i=0; i<strlen(sysop_name); i++ )
        local_sysop_name[i] = 0xFF - sysop_name[i];

    for( i=0; i<strlen(bbs_name); i++ )
        local_bbs_name[i] = bbs_name[i] - 1;

    for( i=0; i<strlen(sysop_name); i++ )
        sum_sysop_name += local_sysop_name[i] * (local_sysop_name[i] % 30) + 1;

    for( i=0; i<strlen(sysop_name); i++ )
        sum_sysop_name += local_sysop_name[i] * (local_sysop_name[i] % 30) + 1;

    sum_sysop_name += (0xFF - strlen(sysop_name)) * ((0xFF - strlen(sysop_name)) % 15) + 1;

    for( i=0; i<strlen(sysop_name); i++ )
    {
        if( i < (strlen(sysop_name)-2) )
            i++;
        sum_sysop_name += 0xFF - local_sysop_name[i];
    }

    for( i=0; i<strlen(sysop_name); i++ )
    {
        if( i < strlen(sysop_name)-2 )
            i++;
        sum_sysop_name += 0xFF - local_sysop_name[i] + 23;
    }
    
    for( i=0; i<strlen(bbs_name); i++ )
        sum_bbs_name += local_bbs_name[i] * (local_bbs_name[i] % 30) + 1;

    for( i=0; i<strlen(bbs_name); i++ )
        sum_bbs_name += local_bbs_name[i] * ((local_bbs_name[i] % 30) + 6) + 1;

    sum_bbs_name += ( ((sum_bbs_name % 15) + 1) * strlen(bbs_name) ) / 2;

    for( i=0; i<strlen(bbs_name); i++ )
    {
        if( i < (strlen(bbs_name)-2) )
            i++;
        sum_bbs_name += local_bbs_name[i];
    }

    sum_sysop_name += (sum_sysop_name % 255);

    reg_key = (sum_sysop_name / 15) * (sum_bbs_name / 2) + 1;
                 
    snprintf( reg_key_ascii, 11, "%ld", reg_key );
                 
    printf( "\n"
            "                                        T H E       @         ############     \n"
            "                                                  @ @           ####     ###   \n"
            "   SuperBBS 1.17.3                                @@@            ###      #### \n"
            "KEYGEN by akacastor 2024-04-05                 @@ @@@@ @@        ###       ####\n"
            "                                             @@@   @@   @@       ###        ###\n"
            "                                           @@     @@@@    @@     ###       ####\n"
            "                                          @@     @@  @     @@    ###       ### \n"
            "                                         @       @@  @@      @   ###     ####  \n"
            "                                         @      @@    @@     @@@@##########    \n"
            "                                         @      @@    @@  @@@@@@ ###           \n"
            "                                         @      @@    @@@@@@ @   ###           \n"
            "                                         @     @@  @@@@@@    @   #M#           \n"
            "                                         @     @@@@@@  @@    @   #t#           \n"
            "Sysop: %-35.35s@@  @@@@      @@ @@    #M#           \n"
            "  BBS: %-36.36s@@@@@        @@@@     ###           \n"
            "Reg #: %-10.10s                        @@@ @@@         @@      ###           \n"
            "                                       @@@   @@ @@@@@@@@ @@@    #####          \n"
            "                                             @@           @@  #########        \n"
            "                                            @@             @@                  \n"
            "                                            @               @       C L A S S  \n"
            "                   guess what... 1994, 2024, your shit's still getting cracked.\n"
            "         it's just now more of a philanthropic move instead of an anarchist one\n",
            sysop_name, bbs_name, reg_key_ascii );
    
    return 0;
}
